----------------------------------------------------------------
-- Normal Bases 2^k-ary Method for Exponentiation (NB_2kary_exp.adb)
--
-- 
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with Gf2m; use Gf2m;
with Finite_Fields_Gf2m; use Finite_Fields_Gf2m;

procedure Nb_2kary_Exp is
   A,B,E,Aux,Aux1: Poly_Vector;
   H: H_Array;
   W: W_Array;
   V,D,G,K,Q: Integer;
   R: R_Array;
   
begin

   ---------------------------------
   for I in 1 .. M/2 loop
      H(I) := 0;
   end loop;
   for I in 1 .. M/2 loop
      for J in 1 .. M-1 loop
         W(I,J) := 0;
      end loop;
   end loop;

   V := M/2;   
   
   for I in 1 .. V loop Put("h(");Put(I);Put(") = "); Get(H(I)); end loop;
   for I in 1 .. V loop 
      for J in 1 .. H(I) loop
         Put("W(");Put(I);Put(",");Put(J);Put(") = "); Get(W(I,J)); 
      end loop;
   end loop; New_Line; New_Line;
   ----------------------------------   
   
   loop

      for I in 0 .. M/2-1 loop
         R(I) := 0;
      end loop;

      for I in 0 .. M-1 loop Put("A(");Put(I);Put(") = "); Get(A(I)); end loop; New_Line;

      Put("E = "); Get(G); New_Line;
   
      E := Inttovect(G); 

      Put("K = "); Get(K); New_Line;   
   
      for I in 0 .. M/K-1 loop
         R(I) := Vectoint_K(E,K,I*K);
      end loop;
   

      for I in 0 .. M-1 loop
         B(I) := 1;
      end loop;

      D := 2**K-1;
      while D >= 1 loop
         Aux := Nb_Exp(A,D,H,W);
         for I in 0 .. M/K-1 loop
            Q := R(I)/D;
            if R(I) = D*(2**Pow2j(Q)) then
               if K*I+Pow2j(Q) = 0 then
                  Aux1 := Aux;
               elsif K*I+Pow2j(Q) = 1 then
                  Aux1 := Nb_Sq(Aux);
               elsif K*I+Pow2j(Q) > 1 then
                  Aux1 := Nb_Sq(Aux);
                  for L in 1 .. (K*I+Pow2j(Q))-1 loop
                     Aux1 := Nb_Multiplier(Aux1,Aux1,H,W);
                  end loop;
               end if;  
               B := Nb_Multiplier(B,Aux1,H,W);
            end if;
         end loop;
         D := D - 2;
      end loop;
            
      -----------------------------------------------------
   
      Put("B = "); for I in 0 .. M-1 loop 
         Put(B(I)); 
      end loop; New_Line; New_Line;
   end loop;
end Nb_2kary_Exp;
