----------------------------------------------------------------
--   for Type-1 Optimal Normal Bases Multiplication with AOPs
--   (NB_T1_multiplier.adb)
--
-- 
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with Gf2m; use Gf2m;
with Finite_Fields_Gf2m; use Finite_Fields_Gf2m;

procedure Nb_T1_Multiplier is
   A,B,C: Poly_Vector;
   R,One: Poly_Vector;
   Yij: Yij_Array;
   Yiv: Yiv_Array;
   K: K_Array;
   V: Integer;
   F: Bit;
   
begin
   loop
      for I in 0 .. M-1 loop 
         Put("A(");Put(I);Put(") = "); Get(A(I)); 
      end loop; New_Line;
      for I in 0 .. M-1 loop 
         Put("B(");Put(I);Put(") = "); Get(B(I)); 
      end loop; New_Line;
     
      V := M/2;
   
      for I in 1 .. V-1 loop
         Put("k(");Put(I);Put(") = "); Get(K(I)); 
      end loop;New_Line;
   
      for I in 0 .. M-1 loop
         R(I) := 0;
         One(I) := 1;
      end loop;
   
      for I in 0 .. M-1 loop
         for J in 1 .. V loop
            Yij(I,J) := M2and(M2xor(A(I),A((I+J) mod M)),M2xor(B(I),B((I+J) mod M)));
         end loop;
      end loop;
      for I in 0 .. V-1 loop
         Yiv(I) := M2and(M2xor(A(I),A((V+I) mod M)),M2xor(B(I),B((V+I) mod M)));
      end loop;

      for I in 0 .. M-1 loop
         C(I) := M2and(A(I),B(I));
      end loop;

      F := Yiv(0);
   
      for J in 1 .. V-1 loop
         for I in 0 .. M-1 loop
            R(I) := Yij(I,J);
         end loop;
         for I in 1 .. K(J) loop
            R := Nb_Sq(R);
         end loop;
         C := M2xvv(C,R);
         F := M2xor(F,Yiv(J));
      end loop;

      if F = 1 then
         C := M2xvv(C,One);
      end if;   
             
      -----------------------------------------------------
   
      Put("C = "); for I in 0 .. M-1 loop 
         Put(C(I)); 
      end loop; New_Line; New_Line;
   end loop;
end Nb_T1_Multiplier;