----------------------------------------------------------------
-- Normal Bases Multiplier (NB_multiplier.adb)
--
-- 
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with GF2m; use GF2m;
with finite_fields_GF2m; use finite_fields_GF2m;

procedure NB_multiplier is
   a,b,c: poly_vector;
   r,t: poly_vector;
   h: h_array;
   w: w_array;
   yij: yij_array;
   v,s,te: integer;
   
begin
loop
   for i in 0 .. m-1 loop 
      Put("A(");Put(i);Put(") = "); Get(a(i)); 
   end loop; New_Line;
   for i in 0 .. m-1 loop 
      Put("B(");Put(i);Put(") = "); Get(b(i)); 
   end loop; New_Line;
   
   for i in 1 .. m/2 loop
      h(i) := 0;
   end loop;
   for i in 1 .. m/2 loop
      for j in 1 .. m-1 loop
         w(i,j) := 0;
      end loop;
   end loop;
   for i in 0 .. m-1 loop
      for j in 1 .. m/2 loop
         yij(i,j) := 0;
      end loop;
   end loop;
   
   v := m/2;
   
   for i in 1 .. v loop
      Put("h(");Put(i);Put(") = "); Get(h(i)); 
   end loop;
   for i in 1 .. v loop 
      for j in 1 .. h(i) loop
         Put("W(");Put(i);Put(",");Put(j);Put(") = "); Get(w(i,j)); 
      end loop;
   end loop; New_Line;
   
   for i in 0 .. m-1 loop
      r(i) := 0;
      t(i) := 0;
   end loop;
   
   for i in 0 .. m-1 loop
      for j in 1 .. v loop
         yij(i,j) := m2and(m2xor(a(i),a((i+j) mod m)),m2xor(b(i),b((i+j) mod m)));
      end loop;
   end loop;
   for i in 0 .. m-1 loop
      c(i) := m2and(a(i),b(i));
   end loop;
   for j in 1 .. v-1 loop
      for i in 0 .. m-1 loop
         t(i) := 0;
      end loop;
      for k in 1 .. h(j) loop
         for i in 0 .. m-1 loop
            r(i) := yij((i-w(j,k)) mod m,j);
         end loop;
         t := m2xvv(t,r); 
      end loop;
      c := m2xvv(c,t);      
   end loop; 
   for i in 0 .. m-1 loop
      t(i) := 0;
   end loop;
   if (m rem 2) /= 0 then
      s := h(v);
      te := m;
   else
      s := h(v)/2;
      te := m/2;
   end if;   
   for i in 0 .. te-1 loop
      yij(i,v) := m2and(m2xor(a(i),a((v+i) mod m)),m2xor(b(i),b((v+i) mod m)));
   end loop;
   if (m rem 2) = 0 then
      for i in 0 .. (m/2)-1 loop 
         yij(i+v,v) := yij(i,v);
      end loop;
   end if;
   for k in 1 .. s loop
      for i in 0 .. te-1 loop
         r(i) := yij((i-w(v,k)) mod m,v);
      end loop;
      if (m rem 2) = 0 then
         for i in 0 .. (m/2)-1 loop
            r(i+m/2) := r(i);
         end loop;        
      end if;
      t := m2xvv(t,r);
   end loop; 
   c:= m2xvv(c,t);
           
-----------------------------------------------------
   
   Put("C = "); for i in 0 .. m-1 loop 
      Put(c(i)); 
   end loop; New_Line; New_Line;
end loop;
end NB_multiplier;